## trompeloeil-cpp 43

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)
project(trompeloeil)

include(GNUInstallDirs)
include(ExternalProject)
include(CMakePackageConfigHelpers)
include(CheckCXXCompilerFlag)

write_basic_package_version_file(
  "${CMAKE_CURRENT_BINARY_DIR}/trompeloeil/trompeloeil-config-version.cmake"
  VERSION 43
  COMPATIBILITY AnyNewerVersion
  ARCH_INDEPENDENT)

add_library(trompeloeil INTERFACE)
add_library(trompeloeil::trompeloeil ALIAS trompeloeil)

set(INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)

target_include_directories(
  trompeloeil
  INTERFACE
    $<BUILD_INTERFACE:${INCLUDE_DIR}>
)

target_include_directories(
  trompeloeil
  INTERFACE
    $<INSTALL_INTERFACE:$<INSTALL_PREFIX>/include>
)

set(MASTER_PROJECT OFF)
if (${CMAKE_CURRENT_SOURCE_DIR} STREQUAL ${CMAKE_SOURCE_DIR})
  set(MASTER_PROJECT ON)
endif()

option(TROMPELOEIL_INSTALL_TARGETS "Sets whether trompeloeil should be installed" ${MASTER_PROJECT})
option(TROMPELOEIL_INSTALL_DOCS "Install documentation" ${TROMPELOEIL_INSTALL_TARGETS})

if (MASTER_PROJECT AND CMAKE_BUILD_TYPE MATCHES Debug)

  if (${CXX_STANDARD})
    set(CMAKE_CXX_STANDARD ${CXX_STANDARD})
  else()
    set(CMAKE_CXX_STANDARD 14)
  endif()
  set(CMAKE_CXX_STANDARD_REQUIRED YES)
  set(CMAKE_CXX_EXTENSIONS OFF)

  set(CATCH_DIR ${CMAKE_CURRENT_BINARY_DIR}/catch)
  if(NOT EXISTS ${CATCH_DIR}/catch.hpp)
    if (NOT EXISTS ${CATCH_DIR})
      make_directory(${CATCH_DIR})
    endif()
    file(
      DOWNLOAD
        https://github.com/catchorg/Catch2/releases/download/v2.13.7/catch.hpp  ${CATCH_DIR}/catch.hpp
      STATUS
        status
      LOG
        log
    )
    list(GET status 0 status_code)
    list(GET status 1 status_string)

    if(NOT status_code EQUAL 0)
      message(FATAL_ERROR "error downloading catch: ${status_string}"
        "${log}")
    endif()
  endif()

  # Assumptions:
  # Clang and GNU compilers run on Linux or Linux-like platforms.
  # MSVC compilers run on Windows platforms.

  if(CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "GNU")

    set(
      LIBCXX_PREFIX_PATH
      "/usr/lib/llvm-8"
      CACHE
      PATH
      "Path prefix to libc++"
    )

    # Interpret CXX_STDLIB, if specified
    if (NOT "${CXX_STDLIB}" STREQUAL "")

      if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")

        # Emulate -stdlib for g++
        if ("${CXX_STDLIB}" STREQUAL "libc++")

          # Disable standard library and
          # set include path to appropriate libc++ headers
          string(CONCAT
                 LIBCXX_INCLUDE_PATH
                 "-isystem"
                 "${LIBCXX_PREFIX_PATH}"
                 "/include/c++/v1")
          string(CONCAT
                 STDLIB_COMPILE_FLAGS
                 "-nostdinc++"
                 " "
                 "${LIBCXX_INCLUDE_PATH}")
          set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${STDLIB_COMPILE_FLAGS}")

        elseif ("${CXX_STDLIB}" STREQUAL "libstdc++")

          # This is the default library for g++, nothing to do.

        else()

          # Unknown CXX_STDLIB option
          message(FATAL_ERROR
                  "CXX_STDLIB only understands libc++ and libstdc++, not "
                  "'${CXX_STDLIB}'")

        endif()

      elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang")

        if (("${CXX_STDLIB}" STREQUAL "libc++") OR
            ("${CXX_STDLIB}" STREQUAL "libstdc++"))

          set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=${CXX_STDLIB}")

        else()

          # Unknown CXX_STDLIB option
          message(FATAL_ERROR
                  "CXX_STDLIB only understands libc++ and libstdc++, not "
                  "'${CXX_STDLIB}'")

        endif()

      else()

        message(FATAL_ERROR
                "Only g++ and Clang++ compilers support CXX_STDLIB")

      endif()

    endif()

    if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
      string(CONCAT
             WARN_FLAGS
             "-Weverything"
             " -Wno-c++98-compat-pedantic"
             " -Wno-padded"
             " -Wno-weak-vtables"
             " -Wno-exit-time-destructors"
             " -Wno-global-constructors")

      # Disable for Catch2.
      # See <https://github.com/catchorg/Catch2/issues/1456>
      check_cxx_compiler_flag("-Wno-extra-semi-stmt" WARN_SEMI_STMT)

      if (WARN_SEMI_STMT)
        string(APPEND
               WARN_FLAGS
               " -Wno-extra-semi-stmt")
      endif()

      # Disable for Catch2.
      # See <https://github.com/catchorg/Catch2/issues/578>
      check_cxx_compiler_flag("-Wno-reserved-identifier" WARN_RESERVED_ID)

      if (WARN_RESERVED_ID)
        string(APPEND
               WARN_FLAGS
               " -Wno-reserved-identifier")
      endif()

    elseif(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
      string(CONCAT
             WARN_FLAGS
             "-Wall"
             " -Wextra"
             " -pedantic"
             " -Wshadow"
             " -Wconversion")
        check_cxx_compiler_flag("-Wnonnull" WARN_NONNULL)

        if (WARN_NONNULL)
            string(APPEND
                    WARN_FLAGS
                    " -Wnonnull")
        endif()
    endif()

    set(WARN_FLAGS "${WARN_FLAGS} -Werror")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${WARN_FLAGS}")

    # Default sanitizer target properties.
    set(TSAN "-fsanitize=undefined,thread")
    set(SSAN "-fsanitize=undefined,address")

    # Exceptions to sanitizer target properties based on compiler and compiler version.
    if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")

      if (NOT (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.0"))
         set(SSAN "-fsanitize=undefined,address -fsanitize-address-use-after-scope")
      else()
        set(SSAN "-fsanitize=undefined,address")
      endif()

    elseif (CMAKE_CXX_COMPILER_ID MATCHES "GNU")

      if ((NOT (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.8")) AND
         (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.9"))
        set(TSAN "-fsanitize=thread")
        set(SSAN "-fsanitize=address")
      endif()

    endif()

  endif() # Clang or GNU

  if(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")

    add_compile_options(/W4)
    add_compile_options(/bigobj)
    add_compile_options(/EHsc)

    check_cxx_compiler_flag(/permissive HAS_PERMISSIVE_FLAG)
    if(HAS_PERMISSIVE_FLAG)
      add_compile_options(/permissive-)
    endif()

  endif() # MSVC

  add_executable(
    self_test
    EXCLUDE_FROM_ALL
    test/compiling_tests.cpp
    test/compiling_tests_11.cpp
    test/compiling_tests_14.cpp
    include/catch2/trompeloeil.hpp)

  target_include_directories(
    self_test
    PRIVATE
    ${CATCH_DIR}
  )

  if (SANITIZE AND NOT APPLE)
    set_target_properties(
      self_test
      PROPERTIES
        LINK_FLAGS
          "${SSAN} -fuse-ld=gold"
        COMPILE_FLAGS
          ${SSAN}
    )
  endif()

  target_link_libraries(
    self_test
    PUBLIC
      trompeloeil
  )

  find_package(Threads REQUIRED)

  add_executable(
    thread_terror
    EXCLUDE_FROM_ALL
    test/thread_terror.cpp
    )

  target_link_libraries(
    thread_terror
    PUBLIC
      trompeloeil
      Threads::Threads
  )

  if (SANITIZE)
    set_target_properties(
      thread_terror
      PROPERTIES
        LINK_FLAGS
          ${TSAN}
        COMPILE_FLAGS
          ${TSAN}
    )
  endif()

  add_executable(
    custom_recursive_mutex
    EXCLUDE_FROM_ALL
    test/custom_recursive_mutex.cpp
  )

  target_link_libraries(
    custom_recursive_mutex
    PUBLIC
    trompeloeil
    Threads::Threads
  )

  if (SANITIZE AND NOT APPLE)
    set_target_properties(
      custom_recursive_mutex
      PROPERTIES
        LINK_FLAGS
          "${SSAN} -fuse-ld=gold"
        COMPILE_FLAGS
          ${SSAN}
      )
  endif()

  # Linker support for CXX_STDLIB argument
  if (NOT ("${CXX_STDLIB}" STREQUAL ""))

    if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")

      if ("${CXX_STDLIB}" STREQUAL "libc++")

        set(LIBCXX_LIBRARY_PATH "${LIBCXX_PREFIX_PATH}/lib")
        set(STDLIB_LINK_FLAGS
          -nodefaultlibs
          -L${LIBCXX_LIBRARY_PATH}
          -Wl,-rpath,${LIBCXX_LIBRARY_PATH}
        )
        set(STDLIB_LINK_LIBRARIES
          "-lc++"
          "-lc++abi"
          "-lm"
          "-lc"
          "-lgcc_s"
          "-lgcc"
        )

        set_target_properties(
          self_test
          PROPERTIES
            LINK_FLAGS
              ${STDLIB_LINK_FLAGS}
        )

        target_link_libraries(
          self_test
          PUBLIC
            ${STDLIB_LINK_LIBRARIES}
        )

        set_target_properties(
          thread_terror
          PROPERTIES
            LINK_FLAGS
              ${STDLIB_LINK_FLAGS}
        )

        target_link_libraries(
          thread_terror
          PUBLIC
            ${STDLIB_LINK_LIBRARIES}
        )

        set_target_properties(
          custom_recursive_mutex
          PROPERTIES
            LINK_FLAGS
              ${STDLIB_LINK_FLAGS}
        )

        target_link_libraries(
          custom_recursive_mutex
          PUBLIC
            ${STDLIB_LINK_LIBRARIES}
        )

      endif()

    endif()

  endif()

  # Shameless hack to get target to work on Windows.
  if(CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "GNU")

    add_custom_target(
      run_self_test
      COMMAND
        ${CMAKE_CURRENT_BINARY_DIR}/self_test
      DEPENDS
        self_test
    )

  else()

    add_custom_target(
      run_self_test
      COMMAND
        ${CMAKE_CURRENT_BINARY_DIR}/Debug/self_test
      DEPENDS
        self_test
    )

  endif()

  if(CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "GNU")

    add_custom_target(
      run_coverage
      COMMAND
        kcov --skip-solibs --include-pattern=trompeloeil.hpp ./coverage ${CMAKE_CURRENT_BINARY_DIR}/self_test
      DEPENDS
        self_test
    )

  endif()

endif() # MASTER_PROJECT AND CMAKE_BUILD_TYPE MATCHES Debug

if (TROMPELOEIL_INSTALL_TARGETS)
install(
  TARGETS
    trompeloeil
  EXPORT
    trompeloeil-targets
  INCLUDES DESTINATION
    include
)

install(
  EXPORT
    trompeloeil-targets
  NAMESPACE
    trompeloeil::
  DESTINATION
    ${CMAKE_INSTALL_LIBDIR}/cmake/trompeloeil
)
install(
  FILES
    trompeloeil-config.cmake
    "${CMAKE_CURRENT_BINARY_DIR}/trompeloeil/trompeloeil-config-version.cmake"
  DESTINATION
    ${CMAKE_INSTALL_LIBDIR}/cmake/trompeloeil
  COMPONENT
    Devel
)

install(
  DIRECTORY
    include/
  DESTINATION
    ${CMAKE_INSTALL_INCLUDEDIR}
)
endif(TROMPELOEIL_INSTALL_TARGETS)

if(TROMPELOEIL_INSTALL_DOCS)
  install(
    FILES
      LICENSE_1_0.txt
    DESTINATION
      ${CMAKE_INSTALL_DOCDIR}
  )

  install(
    DIRECTORY
      docs
    DESTINATION
      ${CMAKE_INSTALL_DOCDIR}
  )
endif()

=== debian/changelog ===
trompeloeil-cpp (43-3) unstable; urgency=medium

  * Added patches for full offline build
  * Marked package as Multi-Arch: Same

 -- Matthias Geiger <matthias.geiger1024@tutanota.de>  Sun, 05 Feb 2023 14:06:59 +0100

trompeloeil-cpp (43-2) unstable; urgency=medium

  * Upload to unstable
  * Source-only upload

 -- Matthias Geiger <matthias.geiger1024@tutanota.de>  Fri, 03 Feb 2023 14:18:26 +0100

trompeloeil-cpp (43-1) experimental; urgency=medium

  * Initial release. (Closes: #1029784)

 -- Matthias Geiger <matthias.geiger1024@tutanota.de>  Fri, 03 Feb 2023 14:12:57 +0100

=== debian/control ===
Source: trompeloeil-cpp
Section: libdevel
Priority: optional
Maintainer: Matthias Geiger <matthias.geiger1024@tutanota.de>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 catch2,
Standards-Version: 4.6.2
Homepage: https://github.com/rollbear/trompeloeil
Vcs-Browser: https://salsa.debian.org/werdahias/trompeloeil-cpp
Vcs-Git: https://salsa.debian.org/werdahias/trompeloeil-cpp.git

Package: libtrompeloeil-cpp-dev
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: mocking framework for C++11/14
 A thread-safe header-only mocking framework for C++11/14.
 This is a header-only library.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
BUILD_DIR=obj-$(DEB_HOST_GNU_TYPE)
include /usr/share/dpkg/architecture.mk

%:
	dh $@


override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Debug

execute_after_dh_auto_build:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd $(BUILD_DIR) && \
	cmake --build ./ -t self_test thread_terror custom_recursive_mutex -j$$((`nproc`-1))
endif

execute_after_dh_auto_test:
	 cd $(BUILD_DIR) && \
	 ./self_test && ./thread_terror && ./custom_recursive_mutex



override_dh_compress:
	dh_compress -X.pdf -X.md

## trompeloeil-cpp 44

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)
project(trompeloeil)

include(GNUInstallDirs)
include(ExternalProject)
include(CMakePackageConfigHelpers)
include(CheckCXXCompilerFlag)

write_basic_package_version_file(
  "${CMAKE_CURRENT_BINARY_DIR}/trompeloeil/trompeloeil-config-version.cmake"
  VERSION 44
  COMPATIBILITY AnyNewerVersion
  ARCH_INDEPENDENT)

add_library(trompeloeil INTERFACE)
add_library(trompeloeil::trompeloeil ALIAS trompeloeil)

set(INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)

target_include_directories(
  trompeloeil
  INTERFACE
    $<BUILD_INTERFACE:${INCLUDE_DIR}>
)

target_include_directories(
  trompeloeil
  INTERFACE
    $<INSTALL_INTERFACE:$<INSTALL_PREFIX>/include>
)

set(MASTER_PROJECT OFF)
if (${CMAKE_CURRENT_SOURCE_DIR} STREQUAL ${CMAKE_SOURCE_DIR})
  set(MASTER_PROJECT ON)
endif()

option(TROMPELOEIL_INSTALL_TARGETS "Sets whether trompeloeil should be installed" ${MASTER_PROJECT})
option(TROMPELOEIL_INSTALL_DOCS "Install documentation" ${TROMPELOEIL_INSTALL_TARGETS})

if (MASTER_PROJECT AND CMAKE_BUILD_TYPE MATCHES Debug)
  add_subdirectory(test)

endif() # MASTER_PROJECT AND CMAKE_BUILD_TYPE MATCHES Debug

if (TROMPELOEIL_INSTALL_TARGETS)
install(
  TARGETS
    trompeloeil
  EXPORT
    trompeloeil-targets
  INCLUDES DESTINATION
    include
)

install(
  EXPORT
    trompeloeil-targets
  NAMESPACE
    trompeloeil::
  DESTINATION
    ${CMAKE_INSTALL_LIBDIR}/cmake/trompeloeil
)
install(
  FILES
    trompeloeil-config.cmake
    "${CMAKE_CURRENT_BINARY_DIR}/trompeloeil/trompeloeil-config-version.cmake"
  DESTINATION
    ${CMAKE_INSTALL_LIBDIR}/cmake/trompeloeil
  COMPONENT
    Devel
)

install(
  DIRECTORY
    include/
  DESTINATION
    ${CMAKE_INSTALL_INCLUDEDIR}
)
endif(TROMPELOEIL_INSTALL_TARGETS)

if(TROMPELOEIL_INSTALL_DOCS)
  install(
    FILES
      LICENSE_1_0.txt
    DESTINATION
      ${CMAKE_INSTALL_DOCDIR}
  )

  install(
    DIRECTORY
      docs
    DESTINATION
      ${CMAKE_INSTALL_DOCDIR}
  )
endif()

=== test/CMakeLists.txt ===
option(TROMPELOEIL_CATCH2_PREBUILT "Major version of prebuilt catch2")
option(TROMPELOEIL_CATCH2_PREFIX "Path to catch2 installation")

if (${CXX_STANDARD})
  set(CMAKE_CXX_STANDARD ${CXX_STANDARD})
else()
  set(CMAKE_CXX_STANDARD 14)
endif()
set(CMAKE_CXX_STANDARD_REQUIRED YES)
set(CMAKE_CXX_EXTENSIONS OFF)

if (${CMAKE_CXX_STANDARD} GREATER 11)
  find_package(Catch2 3 QUIET)
endif()
if (NOT Catch2_FOUND)
  find_package(Catch2 2...<3 QUIET)
  if (NOT Catch2_FOUND)
    set(CATCH_DIR ${CMAKE_CURRENT_BINARY_DIR}/catch)
    if (NOT EXISTS "${CATCH_DIR}/catch2/catch.hpp")
      if (NOT EXISTS ${CATCH_DIR})
        FILE(MAKE_DIRECTORY "${CATCH_DIR}/catch2")
      endif()
      file(
              DOWNLOAD
              https://github.com/catchorg/Catch2/releases/download/v2.13.7/catch.hpp  ${CATCH_DIR}/catch2/catch.hpp
              STATUS
              status
              LOG
              log
      )
      list(GET status 0 status_code)
      list(GET status 1 status_string)

      if(NOT status_code EQUAL 0)
        message(FATAL_ERROR "error downloading catch: ${status_string}"
                "${log}")
      endif()
    endif()
    add_library(Catch2 INTERFACE)
    add_library(Catch2::Catch2 ALIAS Catch2)
    target_include_directories(Catch2 INTERFACE "${CATCH_DIR}")
    set(Catch2_VERSION_MAJOR 2)
  endif()
endif()
if (TARGET Catch2::Catch2WithMain)
  set(CATCH2_MAIN Catch2::Catch2WithMain)
  add_compile_definitions(CATCH2_MAIN)
endif()
add_compile_definitions(CATCH2_VERSION=${Catch2_VERSION_MAJOR})

# Assumptions:
# Clang and GNU compilers run on Linux or Linux-like platforms.
# MSVC compilers run on Windows platforms.

if(CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "GNU")

  set(
          LIBCXX_PREFIX_PATH
          "/usr/lib/llvm-8"
          CACHE
          PATH
          "Path prefix to libc++"
  )

  # Interpret CXX_STDLIB, if specified
  if (NOT "${CXX_STDLIB}" STREQUAL "")

    if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")

      # Emulate -stdlib for g++
      if ("${CXX_STDLIB}" STREQUAL "libc++")

        # Disable standard library and
        # set include path to appropriate libc++ headers
        string(CONCAT
                LIBCXX_INCLUDE_PATH
                "-isystem"
                "${LIBCXX_PREFIX_PATH}"
                "/include/c++/v1")
        string(CONCAT
                STDLIB_COMPILE_FLAGS
                "-nostdinc++"
                " "
                "${LIBCXX_INCLUDE_PATH}")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${STDLIB_COMPILE_FLAGS}")

      elseif ("${CXX_STDLIB}" STREQUAL "libstdc++")

        # This is the default library for g++, nothing to do.

      else()

        # Unknown CXX_STDLIB option
        message(FATAL_ERROR
                "CXX_STDLIB only understands libc++ and libstdc++, not "
                "'${CXX_STDLIB}'")

      endif()

    elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang")

      if (("${CXX_STDLIB}" STREQUAL "libc++") OR
      ("${CXX_STDLIB}" STREQUAL "libstdc++"))

        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=${CXX_STDLIB}")

      else()

        # Unknown CXX_STDLIB option
        message(FATAL_ERROR
                "CXX_STDLIB only understands libc++ and libstdc++, not "
                "'${CXX_STDLIB}'")

      endif()

    else()

      message(FATAL_ERROR
              "Only g++ and Clang++ compilers support CXX_STDLIB")

    endif()

  endif()

  if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    string(CONCAT
            WARN_FLAGS
            "-Weverything"
            " -Wno-c++98-compat-pedantic"
            " -Wno-padded"
            " -Wno-weak-vtables"
            " -Wno-exit-time-destructors"
            " -Wno-global-constructors")

    # Disable for Catch2.
    # See <https://github.com/catchorg/Catch2/issues/1456>
    check_cxx_compiler_flag("-Wno-extra-semi-stmt" WARN_SEMI_STMT)

    if (WARN_SEMI_STMT)
      string(APPEND
              WARN_FLAGS
              " -Wno-extra-semi-stmt")
    endif()

    # Disable for Catch2.
    # See <https://github.com/catchorg/Catch2/issues/578>
    check_cxx_compiler_flag("-Wno-reserved-identifier" WARN_RESERVED_ID)

    if (WARN_RESERVED_ID)
      string(APPEND
              WARN_FLAGS
              " -Wno-reserved-identifier")
    endif()

  elseif(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    string(CONCAT
            WARN_FLAGS
            "-Wall"
            " -Wextra"
            " -pedantic"
            " -Wshadow"
            " -Wconversion")
    check_cxx_compiler_flag("-Wnonnull" WARN_NONNULL)

    if (WARN_NONNULL)
      string(APPEND
              WARN_FLAGS
              " -Wnonnull")
    endif()
  endif()

  set(WARN_FLAGS "${WARN_FLAGS} -Werror")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${WARN_FLAGS}")

  # Default sanitizer target properties.
  set(TSAN "-fsanitize=undefined,thread")
  set(SSAN "-fsanitize=undefined,address")

  # Exceptions to sanitizer target properties based on compiler and compiler version.
  if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")

    if (NOT (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.0"))
      set(SSAN "-fsanitize=undefined,address -fsanitize-address-use-after-scope")
    else()
      set(SSAN "-fsanitize=undefined,address")
    endif()

  elseif (CMAKE_CXX_COMPILER_ID MATCHES "GNU")

    if ((NOT (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.8")) AND
    (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.9"))
      set(TSAN "-fsanitize=thread")
      set(SSAN "-fsanitize=address")
    endif()

  endif()

endif() # Clang or GNU

if(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")

  add_compile_options(/W4)
  add_compile_options(/bigobj)
  add_compile_options(/EHsc)

  check_cxx_compiler_flag(/permissive HAS_PERMISSIVE_FLAG)
  if(HAS_PERMISSIVE_FLAG)
    add_compile_options(/permissive-)
  endif()

endif() # MSVC

add_executable(
        self_test
        EXCLUDE_FROM_ALL
        compiling_tests.cpp
        compiling_tests_11.cpp
        compiling_tests_14.cpp)


if (SANITIZE AND NOT APPLE)
  set_target_properties(
          self_test
          PROPERTIES
          LINK_FLAGS
          "${SSAN} -fuse-ld=gold"
          COMPILE_FLAGS
          ${SSAN}
  )
endif()

target_link_libraries(
        self_test
        PUBLIC
        trompeloeil
        ${CATCH2_MAIN}
        Catch2::Catch2
)


find_package(Threads REQUIRED)

add_executable(
        thread_terror
        EXCLUDE_FROM_ALL
        thread_terror.cpp
)

target_link_libraries(
        thread_terror
        PUBLIC
        trompeloeil
        Threads::Threads
)

if (SANITIZE)
  set_target_properties(
          thread_terror
          PROPERTIES
          LINK_FLAGS
          ${TSAN}
          COMPILE_FLAGS
          ${TSAN}
  )
endif()

add_executable(
        custom_recursive_mutex
        EXCLUDE_FROM_ALL
        custom_recursive_mutex.cpp
)

target_link_libraries(
        custom_recursive_mutex
        PUBLIC
        trompeloeil
        Threads::Threads
)

if (SANITIZE AND NOT APPLE)
  set_target_properties(
          custom_recursive_mutex
          PROPERTIES
          LINK_FLAGS
          "${SSAN} -fuse-ld=gold"
          COMPILE_FLAGS
          ${SSAN}
  )
endif()

# Linker support for CXX_STDLIB argument
if (NOT ("${CXX_STDLIB}" STREQUAL ""))

  if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")

    if ("${CXX_STDLIB}" STREQUAL "libc++")

      set(LIBCXX_LIBRARY_PATH "${LIBCXX_PREFIX_PATH}/lib")
      set(STDLIB_LINK_FLAGS
              -nodefaultlibs
              -L${LIBCXX_LIBRARY_PATH}
              -Wl,-rpath,${LIBCXX_LIBRARY_PATH}
              )
      set(STDLIB_LINK_LIBRARIES
              "-lc++"
              "-lc++abi"
              "-lm"
              "-lc"
              "-lgcc_s"
              "-lgcc"
              )

      set_target_properties(
              self_test
              PROPERTIES
              LINK_FLAGS
              ${STDLIB_LINK_FLAGS}
      )

      target_link_libraries(
              self_test
              PUBLIC
              ${STDLIB_LINK_LIBRARIES}
      )

      set_target_properties(
              thread_terror
              PROPERTIES
              LINK_FLAGS
              ${STDLIB_LINK_FLAGS}
      )

      target_link_libraries(
              thread_terror
              PUBLIC
              ${STDLIB_LINK_LIBRARIES}
      )

      set_target_properties(
              custom_recursive_mutex
              PROPERTIES
              LINK_FLAGS
              ${STDLIB_LINK_FLAGS}
      )

      target_link_libraries(
              custom_recursive_mutex
              PUBLIC
              ${STDLIB_LINK_LIBRARIES}
      )

    endif()

  endif()

endif()

=== debian/changelog ===
trompeloeil-cpp (44-1) unstable; urgency=medium

  * Added cmake minimum version in d/rules
  * Drop parallelization in d/rules (Closes: #1031024)
  * Drop use-proper-catch.diff, amended allow-offline-build.diff

 -- Matthias Geiger <matthias.geiger1024@tutanota.de>  Sun, 11 Jun 2023 13:17:15 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
- cmake,
+ cmake (>= 3.14),
  catch2,
 Standards-Version: 4.6.2
 Homepage: https://github.com/rollbear/trompeloeil

=== debian/rules ===
--- 
+++ 
@@ -14,14 +14,12 @@
 execute_after_dh_auto_build:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	cd $(BUILD_DIR) && \
-	cmake --build ./ -t self_test thread_terror custom_recursive_mutex -j$$((`nproc`-1))
+	cmake --build ./ -t self_test thread_terror custom_recursive_mutex 
 endif
 
 execute_after_dh_auto_test:
-	 cd $(BUILD_DIR) && \
+	 cd $(BUILD_DIR)/test && \
 	 ./self_test && ./thread_terror && ./custom_recursive_mutex
-
-
 
 override_dh_compress:
 	dh_compress -X.pdf -X.md

## trompeloeil-cpp 46

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,9 +6,11 @@
 include(CMakePackageConfigHelpers)
 include(CheckCXXCompilerFlag)
 
+option(TROMPELOEIL_BUILD_TESTS "Build self test programs" off)
+
 write_basic_package_version_file(
   "${CMAKE_CURRENT_BINARY_DIR}/trompeloeil/trompeloeil-config-version.cmake"
-  VERSION 44
+  VERSION 46
   COMPATIBILITY AnyNewerVersion
   ARCH_INDEPENDENT)
 
@@ -37,10 +39,9 @@
 option(TROMPELOEIL_INSTALL_TARGETS "Sets whether trompeloeil should be installed" ${MASTER_PROJECT})
 option(TROMPELOEIL_INSTALL_DOCS "Install documentation" ${TROMPELOEIL_INSTALL_TARGETS})
 
-if (MASTER_PROJECT AND CMAKE_BUILD_TYPE MATCHES Debug)
+if (MASTER_PROJECT AND TROMPELOEIL_BUILD_TESTS)
   add_subdirectory(test)
-
-endif() # MASTER_PROJECT AND CMAKE_BUILD_TYPE MATCHES Debug
+endif()
 
 if (TROMPELOEIL_INSTALL_TARGETS)
 install(

=== debian/changelog ===
trompeloeil-cpp (46-1) unstable; urgency=medium

  * New upstream release 
  * Temporarily disable building of tests because catch2 
    is not available (Closes: #1054714, #1059495)
  * Updated my mail address in d/control and d/copyright

 -- Matthias Geiger <werdahias@riseup.net>  Sat, 30 Dec 2023 01:50:15 +0100

## trompeloeil-cpp 47

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.14)
-project(trompeloeil)
+project(trompeloeil CXX)
 
 include(GNUInstallDirs)
 include(ExternalProject)
@@ -10,7 +10,7 @@
 
 write_basic_package_version_file(
   "${CMAKE_CURRENT_BINARY_DIR}/trompeloeil/trompeloeil-config-version.cmake"
-  VERSION 46
+  VERSION 47
   COMPATIBILITY AnyNewerVersion
   ARCH_INDEPENDENT)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,5 @@
+cmake_minimum_required(VERSION 3.19)
+
 option(TROMPELOEIL_CATCH2_PREBUILT "Major version of prebuilt catch2")
 option(TROMPELOEIL_CATCH2_PREFIX "Path to catch2 installation")
 
@@ -210,12 +212,18 @@
 
 endif() # MSVC
 
+if (${CMAKE_CXX_STANDARD} GREATER_EQUAL 20)
+    set(CXX20TESTS "test_co_mock.cpp")
+else ()
+    set(CXX20TESTS "")
+endif ()
+
 add_executable(
         self_test
-        EXCLUDE_FROM_ALL
         compiling_tests.cpp
         compiling_tests_11.cpp
-        compiling_tests_14.cpp)
+        compiling_tests_14.cpp
+        ${CXX20TESTS})
 
 
 if (SANITIZE AND NOT APPLE)
@@ -242,7 +250,6 @@
 
 add_executable(
         thread_terror
-        EXCLUDE_FROM_ALL
         thread_terror.cpp
 )
 
@@ -266,7 +273,6 @@
 
 add_executable(
         custom_recursive_mutex
-        EXCLUDE_FROM_ALL
         custom_recursive_mutex.cpp
 )

=== debian/changelog ===
trompeloeil-cpp (47-1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:11:51 +1100

trompeloeil-cpp (47-1) unstable; urgency=medium

  * New upstream release 

 -- Matthias Geiger <werdahias@riseup.net>  Fri, 01 Mar 2024 21:59:50 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: trompeloeil-cpp
 Section: libdevel
 Priority: optional
-Maintainer: Matthias Geiger <matthias.geiger1024@tutanota.de>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Matthias Geiger <werdahias@riseup.net>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
#BUILD_DIR=obj-$(DEB_HOST_GNU_TYPE)
#include /usr/share/dpkg/architecture.mk

%:
	dh $@


#override_dh_auto_configure:
#	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Debug
#
#execute_after_dh_auto_build:
#ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
#	cd $(BUILD_DIR) && \
#	cmake --build ./ -t self_test thread_terror custom_recursive_mutex 
#endif
#
#execute_after_dh_auto_test:
#	 cd $(BUILD_DIR)/test && \
#	 ./self_test && ./thread_terror && ./custom_recursive_mutex

override_dh_compress:
	dh_compress -X.pdf -X.md
